<?php
namespace tests\Zeedhi\Framework\ORM;

use Zeedhi\Framework\ORM\ConnectionFactory;

class ConnectionFactoryTest extends \PHPUnit_Framework_TestCase {


    public function testEncryptAndDecrypt(){
        $originalString = "originalString";
        $encryptedString = ConnectionFactory::encrypt($originalString);
        $decryptedString = ConnectionFactory::decrypt($encryptedString);
        $this->assertEquals($originalString, $decryptedString, "Decrypted string must be the equal to original string.");
    }

    public function testFactory() {
        $this->markTestSkipped("server 55 died");
        $connection = ConnectionFactory::factoryWithEncryptedPassword(array(
            'driver'    => 'oci8',
            'user'      => 'ZEEDHI_DEMO',
            'password'  => "F60oiadefIESOskvGANW39GhTJyVeHyBSkzfI1OzNbc=",
            'host'      => '192.168.122.55',
            'port'      => '1521',
            'dbname'    => 'xe'
        ));

        $this->assertInstanceOf("\\Doctrine\\DBAL\\Connection", $connection);
        $column = $connection->fetchColumn("select 1 from dual");
        $this->assertEquals("1", $column);
    }
}
