function KeyboardEventsHandler($timeout, environment, NavigatorService, OrderActionService, ClientNotificationService,  ConcludeQueue, ScreenService, RestEngine, ApplicationContext, templateManager, SocketServiceKDS, SummaryItemsService, Utilities) {

	var self = this;

	var justExecuted = false;

	var lastKeyOne = false;

	this.executeDownEvent = function(event, key) {
		lastKeyOne = false;
		NavigatorService.setNextOrderAsSelected();
	};

	this.tempList = [];

	this.executeUpEvent = function(event, key) {
		lastKeyOne = false;
		let confirmar = 0, canc = 1, libe = 1;
		NavigatorService.setPreviousOrderAsSelected();
	};

	this.executeLeftEvent = function(event, key) {
		lastKeyOne = false;
		var jumps = 1, NRMULTIPULO = environment.getLocalEnvironment().NRMULTIPULO;
		if(NRMULTIPULO && NRMULTIPULO > 1){
			jumps = NRMULTIPULO;
		}

		for (jumps; jumps > 0; jumps--) {
			self.executeUpEvent();
		}
	};

	this.executeRightEvent = function(event, key) {
		lastKeyOne = false;
		var jumps = 1, NRMULTIPULO = environment.getLocalEnvironment().NRMULTIPULO;
		if(NRMULTIPULO && NRMULTIPULO > 1){
			jumps = NRMULTIPULO;
		}
		
		for (jumps; jumps > 0; jumps--) {
			self.executeDownEvent();
		}
	};

	this.executeZoomEvent = function(event, key) {
		lastKeyOne = false;
		var widget = environment.getKDSWidget();
		var projectConfig = environment.getProjectConfig();
		if(widget.kdsType == "expedition" && projectConfig.partialRelease){
			var currentOrder = NavigatorService.getSelectedOrder();
			var tempOrder = widget.getItemsArray(currentOrder);
			if (currentOrder && hasItemOnOrder(tempOrder, 1)) {
				widget.zoomItem = tempOrder;
				NavigatorService.setFirstItemAsSelected(widget.zoomItem);
			}else{
				ScreenService.notificationMessage('Não há itens para serem expedidos separadamente', 'alert', 5200);
			}
			widget.updateKDSTemplate();
		}
	};

	this.executeBackspaceEvent = function() {
		lastKeyOne = false;
		var widget = environment.getKDSWidget();
		widget.completedOrders = {};
		if (environment.getLocalEnvironment().IDHABROLLBKDS == 'S') {
			if (!ConcludeQueue.isQueueEmpty()) {
				var conclusionOrder = ConcludeQueue.pop();
				$timeout.cancel(conclusionOrder.timer);
				conclusionOrder.order.isInConclusionQueue = false;
				conclusionOrder.order.isNewOrder = true;
				if(widget.zoomItem){
					NavigatorService.handleScrollbarOnZoomUp();
				}
				if(!NavigatorService.getSelectedOrder()){
					NavigatorService.setFirstOrderAsSelected();
				}
				widget.updateKDSTemplate();
				conclusionOrder.order.keepOrderColor = false;
			} else {
				ScreenService.alertNotification('Não há pedidos na fila de conclusão!');
			}
		}
	};

	this.confirmExpedition = function(currentOrder){
            let lastSelectedOrderIndex = NavigatorService.getOrderIndex(currentOrder);
			OrderActionService.concludeOrderProduction(currentOrder);
			OrderActionService.orderOnClick(currentOrder);
			ClientNotificationService.notifyClient(currentOrder);
			NavigatorService.unSelectAllOrders();
			ApplicationContext.ShortcutKeyService.bindShortcutsOrderPanel();
			setTimeout(() => {
                NavigatorService.setPreviousOrderAsSelected(lastSelectedOrderIndex);
            }, 300);
	};

	this.executeEnterEvent = function (event, key) {
		lastKeyOne = false;
		if (justExecuted) {
			setTimeout(() => {
				justExecuted = false;
			}, 500);
		}
		else if (!justExecuted) {
			var widget = environment.getKDSWidget();
			var currentOrder = NavigatorService.getSelectedOrder();
			if (currentOrder != undefined) {
				let loader = document.querySelector('aside.zh-background-loading');
				if(loader && loader.style && loader.style.display != "block") {
					if (currentOrder.isCallClientAvailable() && currentOrder.status == 'expedite') {
						currentOrder.dot = false;
						ClientNotificationService.notifyClient(currentOrder);
					}else if(currentOrder.status == undefined && widget.IDHABLIBDIRETOEXP == 'S'){
						ApplicationContext.ShortcutKeyService.bindPopUpKeys();
						ScreenService.confirmMessage(
							'Este pedido ainda está em produção. Tem certeza que deseja expedi-lo?',
							'question', 
							function(){
								ApplicationContext.ShortcutKeyService.unbindPopUpKeys();
								delete currentOrder.dot;
								self.confirmExpedition(currentOrder);
								justExecuted = true;
							},
							function (){ 
								ApplicationContext.ShortcutKeyService.unbindPopUpKeys();
								ApplicationContext.ShortcutKeyService.bindShortcutsOrderPanel();
								justExecuted = true;
							}
						);
					}
				} else{
					ApplicationContext.ShortcutKeyService.bindPopUpKeys();
				}
			}
			OrderActionService.orderOnClick(currentOrder);
		}
        
    };

	this.logoff = function() {
		if(ConcludeQueue.isQueueEmpty()) {
			logoffConfirmation();
		} else {
			openLastOpenedWindow();
			ScreenService.showMessage('Ainda existem pedidos aguardando para serem liberados, favor aguardar');
		}
	};

	function logoffConfirmation() {
		clearKDSWidgetDataSource();
		ApplicationContext.ShortcutKeyService.unbindMappedKeys();
		SocketServiceKDS.logoffBrowser();
		SummaryItemsService.setFixedItems(null);
		environment.unsetLocalEnvironment();
		Utilities.clearAllTimeOutsAndIntervals();
		ScreenService.openWindow('initialParameters');
	}

	function clearKDSWidgetDataSource() {
		var widget =  environment.getKDSWidget();
		widget.dataSource.data = [];
	}

	this.executeOneEvent = function() {
		lastKeyOne = true;
		ApplicationContext.ShortcutKeyService.bindOneMappedKeys();
	};

	this.executeOneOneEvent = function() {
		if (lastKeyOne)
			ApplicationContext.ShortcutKeyService.bindOneOneMappedKeys();
		else 
			ApplicationContext.ShortcutKeyService.bindMappedKeys();
	};

	this.executeOneOneOneEvent = function() {
		if (lastKeyOne) {
			ApplicationContext.ShortcutKeyService.bindPopUpKeys();
			ScreenService.confirmMessage(
				'Deseja sair do setor?',
				'question', 
				function(){
					ApplicationContext.ShortcutKeyService.unbindPopUpKeys();
					logoffConfirmation();
				},
				function (){ 
					setTimeout(() => {
						ApplicationContext.ShortcutKeyService.bindShortcutsOrderPanel();
						ApplicationContext.ShortcutKeyService.unbindPopUpKeys();
					}, 300);
				}
			);
		} else {
			ApplicationContext.ShortcutKeyService.bindMappedKeys();
		}
	};

	this.executeDotEvent = function () {
		lastKeyOne = false;
		var currentOrder = NavigatorService.getSelectedOrder();
		var widget = environment.getKDSWidget();
		if (currentOrder != undefined) {
            
            // IDHABLIBDIRETOEXP = Permite liberacao direta do pedido. S = Sim - N = Nao
			if (currentOrder.isCallClientAvailable() && currentOrder.status == 'expedite' || widget.IDHABLIBDIRETOEXP == 'S') {
				currentOrder.dot = true;
				ClientNotificationService.notifyClient(currentOrder);
			}
		}
	};

	this.executeReloadEvent = function() {
		window.customKDSReload();
	};

	//--------------------Zoom Events
	this.executeZoomBackspaceEvent = function() {
		self.executeBackspaceEvent();
	};

	//This will call expedite function for choosen items on zoom
	function applyExpeditionToTempList(listToConclude){
		listToConclude.forEach( item => {
			ConcludeQueue.insert(item, true);
		});
	}

	this.executeZoomEnterEvent = function (){
		var widget = environment.getKDSWidget();
		var orderItem = NavigatorService.getSelectedOrderItem(widget.zoomItem);
		//anda com o selected do zoom
		if(orderItem.IDSITITPEDFOS == 'F'){
			//Muda o foco
			NavigatorService.setSelectedByOrderKeyZoom(widget.zoomItem, widget.zoomSelectedOrderKey, true);
			//Se tiver subitens ? subitens  [do contrário] item
			orderItem = orderItem.items ? orderItem.items : [orderItem];
			//Coloca na fila de conclusão
			orderItem.isInConclusionQueue = true;
			//Trata cada item de ordemItem, seja um ou vários
			orderItem.forEach(function(item){
				
				NavigatorService.setInConclusionOnDataSource(item);
				if(item.IDSITITPEDFOS == 'F'){
					if(!hasItemOnOrder(widget.zoomItem, 1)){
						if(!hasItemOnOrder(widget.zoomItem, 0)){
							var toDeleteOrder = NavigatorService.getSelectedOrder();
							var index = widget.dataSource.data.indexOf(toDeleteOrder);
							widget.dataSource.data[index].isInConclusionQueue = true;
							NavigatorService.setOrderAsSelected(index, 'move', 'down');
						}
						widget.zoomItem = null;
						widget.bindPanelShortcutKeys();
						widget.updateKDSTemplate();
						//não sei se pode fazer isso mas ta ai
					}else{
						NavigatorService.handleScrollbarOnZoomDown();
					}
					if(item) {
						if(widget) {
							if(widget.zoomItem){
								if (!widget.zoomItem.listToConclude){
									widget.zoomItem.listToConclude = [];
								}
								widget.zoomItem.listToConclude.push(item);
							} else{
								ConcludeQueue.insert(item, true);
							}							
						} else {
							ConcludeQueue.insert(item, true);
						}
					}
				}
			});
		}
	};

	function hasItemOnOrder(order, qtty) {
		var itemQtty = 0, compItemQtty = 0, groupQtty = 0;
		return order && order.some(function(position){
			return position && position.some(function(item){
				if (!item.isInConclusionQueue) {
					if(item.items){
						groupQtty++;
					}else{
						itemQtty++;
					}
				}
				return (itemQtty > qtty && !item.items) || (item.items && item.items.some(function(compItem){
					if (!compItem.isInConclusionQueue) {
						compItemQtty++;
					}
					return compItemQtty > qtty || ((groupQtty + itemQtty) > qtty) ;
				}));
			});
		});
	}

	this.executeZoomZoomEvent = function(event, key) {
		var widget = environment.getKDSWidget();
		if(widget.zoomItem) {
			if(widget.zoomItem.listToConclude){
				applyExpeditionToTempList(widget.zoomItem.listToConclude);
			}
			widget.zoomItem = null;
			widget.bindPanelShortcutKeys();			
			widget.updateKDSTemplate();
		}
	};

	this.executeZoomUpEvent =  function(){
		var widget = environment.getKDSWidget();
		NavigatorService.setSelectedByOrderKeyZoom(widget.zoomItem, widget.zoomSelectedOrderKey, false);
		widget.updateKDSTemplate();
		NavigatorService.handleScrollbarOnZoomUp();
	};

	this.executeZoomDownEvent = function() {
		var widget = environment.getKDSWidget();
		NavigatorService.setSelectedByOrderKeyZoom(widget.zoomItem, widget.zoomSelectedOrderKey, true);
		widget.updateKDSTemplate();
		NavigatorService.handleScrollbarOnZoomDown();
	};

	/* jshint ignore:start */
	this.executeSlashEvent = function () {
		lastKeyOne = false;
		var widget = environment.getKDSWidget();
		var localEnvironment = environment.getLocalEnvironment();
		if(localEnvironment.IDLINHAPRINCIPAL != 'S') {
			ApplicationContext.ShortcutKeyService.unbindMappedKeys();
			ApplicationContext.ShortcutKeyService.bindSlashMappedKeys();
			var popup = localEnvironment.IDTIPOSETOR == 'P' ? templateManager.containers.production.getWidget("lineActivationPassword") : templateManager.containers.expedition.getWidget("lineActivationPassword") ; 
			ScreenService.openPopup(popup);
			setTimeout(() => {
				document.getElementById('linePassword').value = "";
				document.getElementById('linePassword').focus();
			}, 300);
		} else {
			ScreenService.notificationMessage('Não é possível desativar a linha principal.', 'error', 3000);
		}

		NavigatorService.unSelectAllOrders();
		setTimeout(() => {
			NavigatorService.setFirstOrderAsSelected();
		}, 300);
	};

	this.executeSlashEnterEvent = async function () {
		var widget = templateManager.container.getActiveWidget();
		localEnvironment = environment.getLocalEnvironment();
		let CDSETOR = localEnvironment.CDSETOR;
		let checkStatusRoute = '/StatusLineProduction/get';
        var password = widget.getField('linePassword').element.val();
		
        if (password == 5050){
			ScreenService.closePopup(true); 
            var params = {
                requestType: "Row",
                row: {
                        "CDSETOR": CDSETOR
                }
            };
    
			var lineStatusAction = await RestEngine.post(checkStatusRoute, params).then(function (response) {
				if (response.dataset.checkLineProductionStatus.lineStatus[0]) {
					return response.dataset.checkLineProductionStatus.lineStatus[0].IDATIVO == 'S' ? 'desativar' : 'ativar';
				} else {
					return null; 
				}
            }).catch(err => {
                return err;
            });
    
            if(lineStatusAction){
				ApplicationContext.ShortcutKeyService.bindSlashEnterMappedKeys();
                ApplicationContext.ShortcutKeyService.bindPopUpKeys();
                ScreenService.confirmMessage('Deseja ' + lineStatusAction + ' esta linha de produção?',
                    'question',
                    function () {
                        let lineProductionRoute = '/StatusLineProduction/update';
        
                        var params = {
                            requestType: "Row",
                            row: {
								"CDFILIAL": localEnvironment.CDFILIAL,
                                "CDSETOR": CDSETOR
                            }
                        };
        
                        RestEngine.post(lineProductionRoute, params).then(function (response) {
                            console.log(response.dataset);
                        }).catch(err => {
                            return err;
                        })
                        .finally(() => {
                            window.customKDSReload();
                        });
                    },
                    function () { 
						setTimeout(() => {
							ApplicationContext.ShortcutKeyService.bindShortcutsOrderPanel();
							ApplicationContext.ShortcutKeyService.unbindPopUpKeys();
						}, 300);
					}
                );
            } else {
                ScreenService.notificationMessage('Não está parametrizada uma linha de produção neste setor', 'alert', 3000);
            }
        } else {
            ScreenService.notificationMessage('Senha incorreta', 'alert', 3000);
        }
	};

	this.executeSlashEnterEnterEvent = function() {
		setTimeout(() => {
			ApplicationContext.ShortcutKeyService.bindShortcutsOrderPanel();
		}, 300);
	};

	/* jshint ignore:end */
	this.executeSlashSlashEvent = function(){
		ScreenService.closePopup(true); 
        ApplicationContext.ShortcutKeyService.bindShortcutsOrderPanel();
	};

	this.executePicklistEvent = function() {
		lastKeyOne = false;
		var widget = environment.getKDSWidget();
		var currentOrder = NavigatorService.getSelectedOrder();
		if (currentOrder != undefined && currentOrder.items.length > 0) {
            let picklistRoute = '/printPicklist';
			var params = {
				requestType: "Row",
				row: currentOrder.items
			};

			RestEngine.post(picklistRoute, params).then(function(response) {
				if(response.dataset.printPicklist.printed === false) {
					ScreenService.notificationMessage('Impressão por atalho não parametrizada neste setor', 'alert', 3000);
				}
			}) 
			.catch(err => {
				console.log(err);
			});
		}
	};
	
	this.executePriorityPanelEvent = function () {
		lastKeyOne = false;
		try {
			let priorityPanelActive = environment.getLocalEnvironment().IDHABPRIORIDADE == 'S';
			let hasPriorityOrder = environment.getKDSWidget().dataSource.hasPriorityOrders;

			let orderContainerPriority = document.getElementById('priority-orders') || false;
			let orderContainerdefault = document.getElementById('default-orders') || false;
	
			let setDefaultBehaviour = () => {
				NavigatorService.unSelectAllOrders();
				orderContainerdefault && orderContainerdefault.classList.add("selected-container"); // jshint ignore:line
				NavigatorService.setFirstOrderAsSelected();
				orderContainerdefault && orderContainerdefault.scroll({left: 0, behavior: 'smooth'}); // jshint ignore:line
			};
	
			if (priorityPanelActive) {
				if (hasPriorityOrder) {
					if(orderContainerdefault && orderContainerdefault.classList.contains("selected-container") && orderContainerPriority) {
						NavigatorService.unSelectAllOrders();
						orderContainerdefault.classList.remove("selected-container");
						orderContainerPriority.classList.add("selected-container");
						NavigatorService.setFirstOrderAsSelected();
						orderContainerPriority.scroll({top: 0, behavior: 'smooth'});
					} else if (orderContainerPriority && orderContainerPriority.classList.contains("selected-container")) {
						NavigatorService.unSelectAllOrders();
						orderContainerPriority.classList.remove("selected-container");
						orderContainerdefault && orderContainerdefault.classList.add("selected-container"); // jshint ignore:line
						NavigatorService.setFirstOrderAsSelected();
						orderContainerdefault && orderContainerdefault.scroll({left: 0, behavior: 'smooth'}); // jshint ignore:line
					} else {
						setDefaultBehaviour();
					}
				} else {
					ScreenService.notificationMessage('Não há pedidos no painel de pedidos prioritarios', 'alert', 3000);
					setDefaultBehaviour();
				}
			} else {
				ScreenService.notificationMessage('O painel de pedidos prioritarios não esta habilitado para este setor', 'alert', 3000);
				setDefaultBehaviour();
			}    
		} catch (error) {
			console.log('PriorityPanelError');
			console.log(error);
		}
	};
}

Configuration(function(ContextRegister) {
	ContextRegister.register('KeyboardEventsHandler', KeyboardEventsHandler);
});